//
//  ViewController.m
//  重力感应
//
//  Created by 米山 on 2017/8/31.
//  Copyright © 2017年 米可. All rights reserved.
//

#import "ViewController.h"
#import <CoreMotion/CoreMotion.h>
#import "UIColor+ColorExsition.h"


@interface ViewController ()
@property (strong, nonatomic) CMMotionManager *motionManager;

@property (copy, nonatomic) NSMutableArray *balls;//存储view的数组
@property (strong, nonatomic) UIDynamicAnimator *dynamicAnimator;
@property (strong, nonatomic) UIDynamicItemBehavior *dynamicItemBehavior;//弹力

@property (strong, nonatomic) UIGravityBehavior *gravityBehavior;//碰撞
@property (strong, nonatomic) UICollisionBehavior *collisionBehavior;//重力
@property (strong, nonatomic) UIAttachmentBehavior *attachmentBehavior;//实现一个效果让物体跟随手指移动

@property (weak, nonatomic) IBOutlet UIView *testView;


@end

@implementation ViewController
-(NSMutableArray *)balls{
    if (!_balls) {
        _balls = @[].mutableCopy;
    }
    return _balls;
}
- (void)viewDidLoad {
    [super viewDidLoad];
    
    
    self.testView.backgroundColor = [UIColor randomColor];
    self.testView.layer.cornerRadius = 20;
    UIPanGestureRecognizer *pan = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(panGestureRecognizer:)];
    [self.testView addGestureRecognizer:pan];
    
    CGFloat width = 50.f;
    CGFloat hegiht = width;
    for (int i=0; i<100; i++) {
        width = (arc4random()%30)+5;
        UIImageView * ballView = [[UIImageView alloc] init];
        ballView.layer.masksToBounds = YES;
        
        ballView.backgroundColor = [UIColor clearColor];
        
        if (i<=10) {
            ballView.image = [UIImage imageNamed:@"巧克力"];
        }else if(i<=20){
            ballView.image = [UIImage imageNamed:@"裙子"];
        }else if(i<= 30){
            ballView.image = [UIImage imageNamed:@"戒指"];
        }else if(i<=40){
            ballView.image = [UIImage imageNamed:@"玫瑰花"];
        }else if(i<=50){
            ballView.image = [UIImage imageNamed:@"酒杯"];
        }else if(i<=60){
            ballView.image = [UIImage imageNamed:@"性别"];
        }else if(i<=70){
            ballView.image = [UIImage imageNamed:@"礼物"];
        }else if(i<=80){
            ballView.image = [UIImage imageNamed:@"对话框"];
        }else{
            ballView.image = [UIImage imageNamed:@"吻"];
        }
        
        CGFloat temp = (arc4random_uniform(INT32_C(self.view.bounds.size.width - width)))+1;
        ballView.frame = CGRectMake(temp, 0.0, width, width);
        
        [self.view addSubview:ballView];
    
        [self.balls addObject:ballView];

    }
    
    self.dynamicAnimator = [[UIDynamicAnimator alloc] initWithReferenceView:self.view];
    //碰撞
    self.gravityBehavior = [[UIGravityBehavior alloc] initWithItems:self.balls];;
    [self.dynamicAnimator addBehavior:self.gravityBehavior];
    
    self.collisionBehavior = [[UICollisionBehavior alloc] initWithItems:self.balls];
    self.collisionBehavior.translatesReferenceBoundsIntoBoundary = YES;
    [self.dynamicAnimator addBehavior:self.collisionBehavior];
    
    self.dynamicItemBehavior = [[UIDynamicItemBehavior alloc] initWithItems:self.balls];
    self.dynamicItemBehavior.allowsRotation = YES;
    self.dynamicItemBehavior.elasticity = 0.4;
    [self.dynamicAnimator addBehavior:self.dynamicItemBehavior];
    
    self.motionManager = [[CMMotionManager alloc] init];
    self.motionManager.deviceMotionUpdateInterval = 0.01;
    [self.motionManager startDeviceMotionUpdatesToQueue:[NSOperationQueue currentQueue] withHandler:^(CMDeviceMotion * _Nullable motion, NSError * _Nullable error) {
        //重力角度
        CGFloat rotation = atan2(motion.attitude.pitch, motion.attitude.roll);
        self.gravityBehavior.angle = rotation;
    }];
    
}

- (void)panGestureRecognizer:(UIPanGestureRecognizer *)gesture
{
//    CGPoint location = [gesture locationInView:self.view];
//    CGPoint imageLocation = [gesture locationInView:self.testView];
//    switch (gesture.state) {
//        case UIGestureRecognizerStateBegan:
//        {
//            NSLog(@"touch position %@",NSStringFromCGPoint(location));
//            NSLog(@"loction in image %@",NSStringFromCGPoint(imageLocation));
//            [self.dynamicAnimator removeAllBehaviors];
//            
//            UIOffset centerOffset = UIOffsetMake(imageLocation.x - CGRectGetMidX(self.testView.bounds), imageLocation.y - CGRectGetMidY(self.testView.bounds));
//            _attachmentBehavior = [[UIAttachmentBehavior alloc]initWithItem:self.testView offsetFromCenter:centerOffset attachedToAnchor:location];
//            _attachmentBehavior.damping = 0.2;
//            _attachmentBehavior.frequency = 0.5;
//            [self.dynamicAnimator addBehavior:_attachmentBehavior];
//            
//        }
//            break;
//        case UIGestureRecognizerStateEnded:
//        {
//            [self.dynamicAnimator removeBehavior:_attachmentBehavior];
//        }
//            break;
//        default:
//        {
//            [_attachmentBehavior setAnchorPoint:[gesture locationInView:self.view]];
//        }
//            break;
//    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


@end
